竞赛链接
新鲜出炉昨天的双周赛, 这场发挥超常, 最终排名 18 (可能是晚上吃了个蛋糕补充了太多能量?)
总的来说这场双周赛题目相对比较简单, 特别是前三题, 感觉难度都可以算是 easy 吧, 第四题也是经典题目的变种
题目难度: 简单
原题链接
给你一个字符串 s ,字符串的「能量」定义为:只包含一种字符的最长非空子字符串的长度。
请你返回字符串的能量。
s = “leetcode”
2
子字符串 “ee” 长度为 2 ,只包含字符 ‘e’ 。
s = “abbcccddddeeeeedcba”
5
子字符串 “eeeee” 长度为 5 ,只包含字符 ‘e’ 。
s = “triplepillooooow”
5
class Solution:
def maxPower(self, s: str) -> int:
res = 1
cnt = 1
for i in range(1, len(s)):
if s[i] == s[i - 1]:
# 连续, 更新cnt
cnt += 1
res = max(res, cnt)
else:
# 重置cnt
cnt = 1
return res
class Solution {
public:
int maxPower(string s) {
int res = 1;
int cnt = 1;
for (int i = 1; i < s.size(); ++i) {
if (s[i] == s[i-1]) {
res = max(res, ++cnt);
} else {
cnt = 1;
}
}
return res;
}
};
题目难度: 中等
原题链接
给你一个整数 n ,请你返回所有 0 到 1 之间(不包括 0 和 1)满足分母小于等于 n 的 最简 分数 。分数可以以 任意 顺序返回。
n = 2
[“1/2”]
“1/2” 是唯一一个分母小于等于 2 的最简分数。
n = 4
[“1/2”,“1/3”,“1/4”,“2/3”,“3/4”]
“2/4” 不是最简分数,因为它可以化简为 “1/2” 。
n = 1
[]
import math
class Solution:
def simplifiedFractions(self, n: int) -> List[str]:
res = []
for fenmu in range(2, n + 1):
for fenzi in range(1, fenmu):
if math.gcd(fenzi, fenmu) == 1:
res.append(str(fenzi) + '/' + str(fenmu))
return res
class Solution {
public:
vector<string> simplifiedFractions(int n) {
vector<string> res;
for (int b = 2; b <= n; ++b) {
for (int a = 1; a < b; ++a) {
if (gcd(a, b) == 1) {
res.push_back(to_string(a) + '/' + to_string(b));
}
}
}
return res;
}
};
class Solution:
def simplifiedFractions(self, n: int) -> List[str]:
res = []
v = set()
for fenmu in range(2, n + 1):
for fenzi in range(1, fenmu):
value = fenzi / fenmu
if value not in v:
v.add(value)
res.append(str(fenzi) + '/' + str(fenmu))
return res
class Solution
{
public:
vector<string> simplifiedFractions(int n)
{
auto res = vector<string>();
auto v = unordered_set<double>();
for (int fenmu = 2; fenmu <= n; ++fenmu)
{
for (int fenzi = 1; fenzi < fenmu; ++fenzi)
{
double value = (double)fenzi / fenmu;
if (!v.count(value))
{
v.insert(value);
res.push_back(to_string(fenzi) + "/" + to_string(fenmu));
}
}
}
return res;
}
};
题目难度: 中等
原题链接
给你一棵根为 root 的二叉树,请你返回二叉树中好节点的数目。
「好节点」X 定义为:从根到该节点 X 所经过的节点中,没有任何节点的值大于 X 的值。
root = [3,1,4,3,null,1,5]
4
图中蓝色节点为好节点。
root = [3,3,null,4,2]
3
节点 2 -> (3, 3, 2) 不是好节点,因为 “3” 比它大。
root = [1]
1
class Solution:
def goodNodes(self, root: TreeNode) -> int:
self.res = 0
def dfs(node, curmx):
if not node:
return
if node.val >= curmx:
self.res += 1
curmx = max(curmx, node.val)
dfs(node.left, curmx)
dfs(node.right, curmx)
dfs(root, -float('inf'))
return self.res
class Solution {
public:
int goodNodes(TreeNode* root) {
int res = 0;
function<void(TreeNode*, int)> dfs = [&](TreeNode* node, int curmx) {
if (!node) {
return;
}
if (node->val >= curmx) {
curmx = node->val;
++res;
}
dfs(node->left, curmx);
dfs(node->right, curmx);
};
// 这里是根据数据范围定的一个最小值
dfs(root, -1e6);
return res;
}
};
题目难度: 困难
原题链接
给你一个整数数组 cost 和一个整数 target 。请你返回满足如下规则可以得到的 最大 整数:
给当前结果添加一个数位(i + 1)的成本为 cost[i] (cost 数组下标从 0 开始)。
总成本必须恰好等于 target 。
添加的数位中没有数字 0 。
由于答案可能会很大,请你以字符串形式返回。
如果按照上述要求无法得到任何整数,请你返回 “0” 。
cost = [4,3,2,5,6,7,2,5,5], target = 9
“7772”
添加数位 ‘7’ 的成本为 2 ,添加数位 ‘2’ 的成本为 3 。所以 “7772” 的代价为 23+ 31 = 9 。 “997” 也是满足要求的数字,但 “7772” 是较大的数字。
数字 | 成本 |
---|---|
1 | 4 |
2 | 3 |
3 | 2 |
4 | 5 |
5 | 6 |
6 | 7 |
7 | 2 |
8 | 5 |
9 | 5 |
cost = [7,6,5,5,5,6,8,7,8], target = 12
“85”
添加数位 ‘8’ 的成本是 7 ,添加数位 ‘5’ 的成本是 5 。“85” 的成本为 7 + 5 = 12 。
cost = [2,4,6,2,4,6,4,4,4], target = 5
0
class Solution:
def largestNumber(self, cost: List[int], target: int) -> str:
dp = [''] + [None] * target
for i in range(1, len(cost) + 1):
for v in range(cost[i - 1], target + 1):
if dp[v - cost[i - 1]] is not None:
newval = str(i) + dp[v - cost[i - 1]]
if dp[v] is None or int(newval) > int(dp[v]):
dp[v] = newval
return '0' if dp[target] is None else dp[target]
class Solution {
public:
string largestNumber(vector<int>& cost, int target) {
vector<string> dp(target + 1, "NAN");
dp[0] = "";
// 将字符串转成整数会溢出,因此特别写需要一个比较大小的函数
auto largeThan = [](string& s1, string& s2) {
if (s1.size() > s2.size()) {
return true;
}
if (s1.size() < s2.size()) {
return false;
}
return s1 > s2;
};
for (int i = 1; i <= cost.size(); ++i) {
for (int v = cost[i - 1]; v <= target; ++v) {
if (dp[v - cost[i - 1]] != "NAN") {
string newVal = to_string(i) + dp[v - cost[i - 1]];
if (dp[v] == "NAN" || largeThan(newVal, dp[v])) {
dp[v] = newVal;
}
}
}
}
return dp[target] == "NAN" ? string("0") : dp[target];
}
};
大家可以在下面这些地方找到我~
我的知乎专栏
我的 CSDN
我的简书
我的 Leetcode
我的牛客网博客
我的公众号: 每日精选算法题, 欢迎大家扫码关注~